
package de.ivu.elect.presentation.gebietsbaum.menu;

import javax.inject.Inject;

import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahl.boundary.WahlterminSessionSelect;
import de.ivu.elect.presentation.gebietsbaum.GebietUebernehmenView;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;

public class GebietUebernehmenMenuItemEntry extends AbstractGebietMenuItemEntry {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient WahlterminSessionSelect wahlterminSelect;

  public GebietUebernehmenMenuItemEntry() {
    super();
  }

  @Override
  protected UseCasePermission getUseCasePermission() {
    return UseCasePermission.GEBIET_UEBERNEHMEN;
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return KEINE_GEBIET_SECURITY;
  }

  @Override
  public boolean isDisabledInternal() {
    return /** nicht notwenig super.isDisabledInternal() && */
    !isWahlOrWahlterminSelected();
  }

  protected boolean isWahlOrWahlterminSelected() {
    return wahlterminSelect.isSelected();
  }

  @Override
  public String getTargetViewId() {
    return GebietUebernehmenView.VIEW_ID;
  }

  @Override
  public String getLabelKey() {
    return "gebiet.uebernehmen.menu.item.label";
  }

  @Override
  public String getIcon() {
    return getIcons().getIconCopy();
  }
}
